﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=5.82
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Dim xui As XUI
	
	'----------------------------------------------------------------------------------------
	'Network Variables
	
'	Private Astream As AsyncStreams

	
'	Dim tempInt(2) As Int
'	Dim buffTempInt(16) As Byte
'	Dim buffTempIntForFloat(14 * 4) As Byte
	'	Dim jTime As Double
	
	Public IsConnected As Boolean
	Public TCPSocket As Socket
	Public tcpStream As AsyncStreams
	
	Public noServerRequests As Long
	Public noServerErrors   As Long
	
	Type NWrkRecord_t(ssid As String, securityType As String, signalStrengthdB As Float, saved As Boolean)
	'    Dim NWrkRec As NWrkRecord_t
	
	Dim NWrkRealTimeDataTmr As Timer
	Dim CmdTimeoutTmr As Timer
	
	Dim NWrkTransactionInProgress As Boolean
	
	Dim tempDouble(2) As Double
	Dim tempFloat(14) As Float
	Dim jTime As Double
	
	Dim startTime As String
	Dim endTime As String
	
	Dim lastDataJulianDate As Double
	
	Dim Const ipAddress = "192.168.1.111" As String
	Dim Const port 		= 49152 As Int
	Dim Const passCode  = "1E28EC57" As String
	Dim passcodeInt As Int
	
	Dim passCodeByteArray(8) As Byte
	
	Dim Const  NW_OK = 0 As Int
	Dim Const  NW_ERROR = 1 As Int
	

	Dim txBuffGetRealTimePowerData(20) As Byte

	'----------------------------------------------------------------------------------------
	'Command Groups 		
	Dim Const GRP_NULL 						=   0 As Int
	Dim Const GRP_GET_INST_DATA 			=	1 As Int
	Dim Const GRP_SEND_CMD_NO_DATA 			=	2 As Int

	'Command Numbers Group 1                                                    */
	Dim Const CMD_1_NULL					=	0 As Int
	Dim Const CMD_1_GET_PWR_DATA			=	1 As Int
	Dim Const CMD_1_GET_PWR_DATA_LEN		=  116 As Int
	Dim Const CMD_1_GET_SYS_DATA			=	2 As Int

	'Command Numbers Group 2                                                    */
	Dim Const CMD_2_RESET_ALARM_AUDIBLE 	=	3 As Int
	
	'*************************************************************************************************************
	' Realtime data
	Dim const NO_SAMPLES = 3600 As Int

	Public ptrIn As Short
	
	Public arrayJTimeEmbed(NO_SAMPLES) 	As Double
	Public arrayJTimeClient(NO_SAMPLES) As Double
	Public arrayFreq(NO_SAMPLES)  		As Double
	Public arrayVrms(NO_SAMPLES)  		As Float
	Public arraySupplykW(NO_SAMPLES)  	As Double
	Public arraySolarkW(NO_SAMPLES)  	As Float
	Public arrayLoadkW(NO_SAMPLES)  	As Float
	Public arrayQuality(NO_SAMPLES)  	As Byte
	
	Public maxV As Float
	Public minV As Float
	
	Public maxF As Float
	Public minF As Float
	
	Public maxSupplykW As Float
	Public minSupplykW As Float
	
	Public maxSolarkW As Float
	Public minSolarkW As Float
	
	Public maxLoadkW As Float
	Public minLoadkW As Float
	
	Public maxQuality As Byte
	Public minQuality As Byte

	Public Const Q_FREQUENCY 	= 0x01 As Byte
	Public Const Q_VRMS 		= 0x02 As Byte
	Public Const Q_I1 			= 0x04 As Byte
	Public Const Q_I2 			= 0x08 As Byte
	Public Const Q_I3 			= 0x10 As Byte

	'*********************************************************************************
	' Realtime data
	#Region  realtimeSataStruct	
	Type rtData_t(	CommandGroup		As Int, _
					CommandNum			As Int, _
					jTimeEmbed			As Double, _
					Frequency 			As Double, _
					Vrms 				As Float, _
					RoCoF 				As Float, _
					RoCoVrms			As Float, _
					I1rms 				As Float, _
					I2rms 				As Float, _
					I3rms 				As Float, _
					P1 					As Float, _
					P2 					As Float, _
					P3 					As Float, _
					Q1 					As Float, _
					Q2 					As Float, _
					Q3 					As Float, _
					CPUTemp       		As Float, _ 	
					MainBatVolts       	As Float, _ 	
					flashMemError       As Byte, _
					freqMeasRefClkError As Byte, _
					realTimeProcError  	As Byte, _					
					freqMeasInputError  As Byte, _					
					offsetLimitVrms     As Byte, _
					offsetLimitI1       As Byte, _					
					offsetLimitI2       As Byte, _
					offsetLimitI3       As Byte, _
					refErrorVrms        As Byte, _
					refErrorI1          As Byte, _
					refErrorI2          As Byte, _
					refErrorI3			As Byte, _	
					refErrorStdDevVrms  As Byte, _ 
					refErrorStdDevI1    As Byte, _
					refErrorStdDevI2    As Byte, _
					refErrorStdDevI3    As Byte, _
					sdCardError         As Byte, _
					rtcGPSError         As Byte, _					
					MainBatteryVoltsErr As Byte, _
					VBatVoltsErr        As Byte, _
					VRefDiffVoltsErr    As Byte, _
					ProcessorTempErr    As Byte, _
					quality			    As Byte _
					)
    
	Public rtData_s As rtData_t

#End Region	

	Dim tempInt(2) As Int
	Dim buffTempInt(16) As Byte
	Dim buffTempIntForFloat(14 * 4) As Byte

	Public SQL As SQL
	Dim databseInsertInProgress As Boolean

	Private btnRequestData As Button
	Private mainMenuBar As MenuBar
End Sub ' Globals


'======================================================================================
Sub NetWorkService_Create
	'This is the program entry point.

	' Create the pass code array for transmit to reduce network overhead
	Dim Conv As ByteConverter
	Dim pc(1) As Int
	Dim tempInt(4) As Int
	Dim tempByte(6) As Byte

	Conv.LittleEndian = True
	Conv.LittleEndian = True
	
	pc(0) = utils.ConvertHexStringToInt(passCode) 'B4a doesn't do hex. Damn!!
	passcodeInt = pc(0)
	passCodeByteArray = Conv.IntsToBytes(pc)
	
	' Create the Get realtime data array as we will use this every 2 to 2 seconds
	'Include pass code at start of data packet
	Conv.ArrayCopy(passCodeByteArray, 0, txBuffGetRealTimePowerData, 0, 4)

			
	'Include the Command group in the data packet
	tempInt(0) = 20					' Data Length
	tempInt(1) = GRP_GET_INST_DATA 	' Cmd Group
	tempInt(2) = CMD_1_GET_PWR_DATA	' Cmd Number
	tempInt(3) = 0xABCDEF12			' Data Flag
	
	tempByte = Conv.IntsToBytes(tempInt)
	
	' Now append to transmit buffer
	Conv.ArrayCopy(tempByte, 0, txBuffGetRealTimePowerData, 4, 16)

	'Set the date and time formats
	DateTime.DateFormat = "YYY-MM-DD"
	DateTime.TimeFormat = "HH:MM:SS.SSS"
	
	'Open the Real Time Data MS Access Database

	Try
		SQL.InitializeSQLite("G:/PSM_Server_DB/", "psmdb_winSvr.db", False )
	Catch
		Log(LastException.Message)
	End Try

	'Start the NWrk and connect a socket for comms with the embedded server
	connectTCPSocket

	rtData_s.Initialize

	startTime = DateTime.Time(DateTime.Now)
	
	'Initialise the timer that requests power monitor realtime data
	If NWrkRealTimeDataTmr.IsInitialized = False Then
		NWrkRealTimeDataTmr.Initialize("tmr_NWrkRealTimeData", 2000)
	End If

End Sub


'======================================================================================
Sub connectTCPSocket
	If TCPSocket.IsInitialized Then
		TCPSocket.Close
	End If
	
	TCPSocket.Initialize("rxTCP")
	
	Try
		TCPSocket.Connect(ipAddress, port, 5000)
		wait for TCPSocket_Connected(Successful As Boolean)
	Catch
		Log(LastException.Message)
	End Try	

	'Start the realtime data acquisition timer
	If NWrkRealTimeDataTmr.IsInitialized = True Then
		NWrkRealTimeDataTmr.Enabled = True
	End If
	
	'Start the comms timeout timer
	If CmdTimeoutTmr.IsInitialized = False Then
		CmdTimeoutTmr.Initialize("tmr_CmdTimeoutTmr", 10000)
	End If
	
End Sub

'======================================================================================
Sub rxTCP_Connected (Successful As Boolean)
	If Successful = True Then
		If tcpStream.IsInitialized = False Then
			tcpStream.InitializePrefix(TCPSocket.InputStream, False, TCPSocket.OutputStream, "tcpStream")
			Main.lblStatus.Text = "Server Connected " & ipAddress & ":" & port & "  @ " & DateTime.Date(DateTime.Now) & " " &DateTime.Time(DateTime.Now)
			Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors
			
			'Start the realtime data acquisition timer
			If NWrkRealTimeDataTmr.IsInitialized = True Then
				NWrkRealTimeDataTmr.Enabled = True
			End If
	
			'Start the comms timeout timer
'			If CmdTimeoutTmr.IsInitialized = False Then
'				CmdTimeoutTmr.Initialize("tmr_CmdTimeoutTmr", 10000)
'				CmdTimeoutTmr.Enabled = True
'			End If
		End If
	Else
		'Stop the realtime data acquisition timer
		If NWrkRealTimeDataTmr.IsInitialized = True Then
			NWrkRealTimeDataTmr.Enabled = False
		End If
	
		'Start the comms timeout timer
		If CmdTimeoutTmr.IsInitialized = False Then
			CmdTimeoutTmr.Initialize("tmr_CmdTimeoutTmr", 10000)
		End If
		
		'Stop the comms timeout timer
		If CmdTimeoutTmr.IsInitialized = False Then
			CmdTimeoutTmr.Enabled = False
		End If
		
		xui.MsgboxAsync("Could Not Connect TCPSocket", "Establish Comms")
		Main.lblStatus.Text = "Server Error 1: Cannot connect to " & ipAddress & ":" & port & "  @ " & DateTime.Date(DateTime.Now) & " " &DateTime.Time(DateTime.Now)
		Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors
		Sleep(250)
		connectTCPSocket
		
	End If
End Sub


'======================================================================================
Sub tmr_NWrkRealTimeData_Tick
	If NWrkTransactionInProgress = True Then Sleep(50)
	NWrkTransactionInProgress = True
	sendCommand(GRP_GET_INST_DATA, CMD_1_GET_PWR_DATA)
	Wait For CanContinue
End Sub

'======================================================================================
Sub tmr_CmdTimeoutTmr_Tick
	CmdTimeoutTmr.Enabled = False
	NWrkRealTimeDataTmr.Enabled = False
	TCPSocket.Close
	Do While TCPSocket.IsInitialized = True
		Sleep(10)	
	Loop	
	
	connectTCPSocket
	NWrkTransactionInProgress = False
End Sub

'======================================================================================
Sub sendCommand(cmdGroup As Short, cmdNum As Short) As Int

	Dim result = NW_OK As Int

	noServerRequests = noServerRequests + 1
	
	If TCPSocket.Connected = False Then
		Public noServerRequests As Long
		noServerErrors = noServerErrors + 1
		Main.lblStatus.Text = "Server Error 2: Cannot connect to " & ipAddress & ":" & port & "  @ " & DateTime.Date(DateTime.Now) & " " &DateTime.Time(DateTime.Now)
		Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors
		Return NW_ERROR
	End If

	Select cmdGroup
		Case GRP_GET_INST_DATA	' Get Parameters from Controller
			If cmdNum = CMD_1_GET_PWR_DATA Then
				Try	 
					If TCPSocket.Connected Then
						If	tcpStream.Write(txBuffGetRealTimePowerData) = False Then
							Main.lblStatus.Text = "Server Error 3: Cannot connect to " & ipAddress & ":" & port & "  @ " & DateTime.Date(DateTime.Now) & " " &DateTime.Time(DateTime.Now)
							Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors & "  @ " & DateTime.Date(DateTime.Now) & " " &DateTime.Time(DateTime.Now)
							xui.MsgboxAsync("TCP Stream Write Error", "Send sendCommand")
							noServerErrors = noServerErrors + 1
							NWrkRealTimeDataTmr.Enabled = False
							connectTCPSocket
							Log("Tx ERROR: " & ipAddress & " : " & port & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now))
						Else
							Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors & "  @ " & DateTime.Date(DateTime.Now) & " " &DateTime.Time(DateTime.Now)
							Log("Tx OK: " & ipAddress & " : " & port & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now))
						End If
					Else
						NWrkRealTimeDataTmr.Enabled = False
						connectTCPSocket
						'				#If LOGGING_ON
						Log("Tx Error: " & ipAddress & " : " & port & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now))
						'				#End If
						Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors  & "  @ " & DateTime.Date(DateTime.Now) & " " &DateTime.Time(DateTime.Now)
					End If
				Catch
					Main.lblStatus.Text = "Server Error 4: Cannot connect to " & ipAddress & ":" & port & "  @ " & DateTime.Date(DateTime.Now) & " " &DateTime.Time(DateTime.Now)
					Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors
				End Try
			Else
				result = transmitCommand(cmdNum)
			End If
		Case GRP_SEND_CMD_NO_DATA
	
	End Select
'	CmdTimeoutTmr.Enabled = True debug
	
	Return result
End Sub

'======================================================================================
Sub transmitCommand(cmdNum As Short) As Int

	Dim txBuffGetRealTimePowerData(10) As Byte

	Select cmdNum
		Case CMD_1_GET_PWR_DATA	' Get Realtime Power Data

			If tcpStream.Write(txBuffGetRealTimePowerData) = False Then
				Main.lblStatus.Text = "Server Error 5: Cannot connect to " & ipAddress & ":" & port & "  @ " & DateTime.Date(DateTime.Now) & " " &DateTime.Time(DateTime.Now)
				Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors
				xui.MsgboxAsync("TCP Stream Write Error", "Send sendCommand")
				noServerErrors = noServerErrors + 1
			Else
				Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors  & "  @ " & DateTime.Date(DateTime.Now) & " " &DateTime.Time(DateTime.Now)
			End If
			#If LOGGING_ON
		'			Log("Tx: " & strBuff)
			#End If			
	End Select
	
	Return NW_OK
End Sub


'======================================================================================
Sub tcpStream_NewData (buffer() As Byte)
	Dim tcpConv As ByteConverter
	tcpConv.LittleEndian = True
	
	Log("Rx: " & ipAddress & " : " & port & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now))
'	endTime = DateTime.Time(DateTime.Now)
'

		CmdTimeoutTmr.Enabled = False 'Reset comms timeout timer


		'Check the message is valid and which type it is
		buffTempInt(0) = buffer(0)
		buffTempInt(1) = buffer(1)
		buffTempInt(2) = buffer(2)
		buffTempInt(3) = buffer(3)
		
		buffTempInt(4) = buffer(4)
		buffTempInt(5) = buffer(5)
		buffTempInt(6) = buffer(6)
		buffTempInt(7) = buffer(7)
			
		buffTempInt(8) = buffer(8)
		buffTempInt(9) = buffer(9)
		buffTempInt(10) = buffer(10)
		buffTempInt(11) = buffer(11)
			
		buffTempInt(12) = buffer(12)
		buffTempInt(13) = buffer(13)
		buffTempInt(14) = buffer(14)
		buffTempInt(15) = buffer(15)

		tempInt = tcpConv.IntsFromBytes(buffTempInt)

		
		If tempInt(0) <> passcodeInt Then
'			ToastMessageShow("Communication Error Occurred", True)
			Return
		End If

		'Process the data based on the data type
		Select tempInt(2)
			'------------------------------------------------------------------------------
			Case GRP_GET_INST_DATA	' Set Parameters - Handle acknowledge
			Select tempInt(3)
				Case CMD_1_GET_PWR_DATA
					If buffer.Length <> CMD_1_GET_PWR_DATA_LEN Then
						Return
					End If
				
					'Get the Julian Date and System Frequency - both doubles
					'--------------------------------------------------------------------------
					tcpConv.ArrayCopy(buffer, 20, buffTempInt, 0, 16)
					tempDouble = tcpConv.DoublesFromBytes(buffTempInt)
				
					jTime = (tempDouble(0) - Floor(tempDouble(0))) * 24
					
					#If LOGGING_ON
					'Log("1. A Streams New Data " & buffer.Length & " bytes " & maths.SecondsBetweenTimes(startTime, endTime))
					Log(maths.SecondsBetweenTimes(startTime, endTime) & ", " & tempDouble(0) & ", " & ((tempDouble(0) - lastDataJulianDate) * 86400))
					startTime = endTime
					lastDataJulianDate = tempDouble(0)
					#End If

					'Get the floating point amd double vars bytes and covert them
					'--------------------------------------------------------------------------
					tcpConv.ArrayCopy(buffer, 36, buffTempIntForFloat, 0, 14 * 4)
					tempFloat = tcpConv.FloatsFromBytes(buffTempIntForFloat)


					rtData_s.jTimeEmbed 			= tempDouble(0)
					rtData_s.Frequency 				= tempDouble(1)
			
					rtData_s.Vrms					= tempFloat(0)
					rtData_s.RoCoF					= tempFloat(1)
					rtData_s.RoCoVrms				= tempFloat(2)
					rtData_s.I1rms					= tempFloat(3)
					rtData_s.I2rms					= tempFloat(4)
					rtData_s.I3rms					= tempFloat(5)
					rtData_s.P1						= tempFloat(6)
					rtData_s.P2						= tempFloat(7)
					rtData_s.P3						= tempFloat(8)
					rtData_s.Q1						= tempFloat(9)
					rtData_s.Q2						= tempFloat(10)
					rtData_s.Q3						= tempFloat(11)
					rtData_s.CPUTemp				= tempFloat(12)
					rtData_s.MainBatVolts			= tempFloat(13)

					rtData_s.flashMemError			= buffer(84)
					rtData_s.freqMeasRefClkError	= buffer(85)
					rtData_s.realTimeProcError		= buffer(86)
					rtData_s.freqMeasInputError		= buffer(87)
					rtData_s.offsetLimitVrms		= buffer(88)
					rtData_s.offsetLimitI1			= buffer(89)
					rtData_s.offsetLimitI2			= buffer(90)
					rtData_s.offsetLimitI3			= buffer(91)
					rtData_s.refErrorVrms			= buffer(92)
					rtData_s.refErrorI1				= buffer(93)
					rtData_s.refErrorI2				= buffer(94)
					rtData_s.refErrorI3				= buffer(95)
					rtData_s.refErrorStdDevVrms		= buffer(96)
					rtData_s.refErrorStdDevI1		= buffer(97)
					rtData_s.refErrorStdDevI2		= buffer(98)
					rtData_s.refErrorStdDevI3		= buffer(99)
					rtData_s.sdCardError			= buffer(100)
					rtData_s.rtcGPSError			= buffer(101)
					rtData_s.MainBatteryVoltsErr	= buffer(102)
					rtData_s.VBatVoltsErr			= buffer(103)
					rtData_s.VRefDiffVoltsErr		= buffer(104)
					rtData_s.ProcessorTempErr		= buffer(105)
					rtData_s.Quality				= buffer(106)
					
					'Add record to database
					insert_realtimeData

					CallSubDelayed(Me, "CanContinue")
					NWrkTransactionInProgress = False
				End Select	
				'------------------------------------------------------------------------------
		End Select

End Sub


'================================================================================================
Sub insert_realtimeData
	Dim dateTimeStr As String
	
	dateTimeStr = DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now)
	If databseInsertInProgress = False Then
		Try
			DateTime.DateFormat = "YYYY-MM-DD HH:MM:SS.SSS"
			databseInsertInProgress = True
			SQL.BeginTransaction
			SQL.ExecNonQuery2("INSERT INTO tblRealTimeData VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", _
								Array As Object( _
								rtData_s.jTimeEmbed, _ 
								rtData_s.Frequency, _
								rtData_s.Vrms, _
								rtData_s.RoCoVrms, _									
								rtData_s.RoCoF, _
								rtData_s.I1rms, _										
								rtData_s.I2rms, _
								rtData_s.I3rms, _
								rtData_s.P1, _
								rtData_s.P2, _
								rtData_s.P3, _
								rtData_s.Q1, _
								rtData_s.Q2, _
								rtData_s.Q3, _									
								rtData_s.CPUTemp, _
								rtData_s.MainBatVolts, _	
								rtData_s.flashMemError, _
								rtData_s.freqMeasRefClkError, _
								rtData_s.realTimeProcError, _
								rtData_s.freqMeasInputError, _
								rtData_s.offsetLimitVrms, _
								rtData_s.offsetLimitI1, _
								rtData_s.offsetLimitI2, _
								rtData_s.offsetLimitI3, _
								rtData_s.refErrorVrms, _
								rtData_s.refErrorI1, _
								rtData_s.refErrorI2, _
								rtData_s.refErrorI3, _
								rtData_s.refErrorStdDevVrms, _
								rtData_s.refErrorStdDevI1, _
								rtData_s.refErrorStdDevI2, _
								rtData_s.refErrorStdDevI3, _
								rtData_s.sdCardError, _
								rtData_s.rtcGPSError, _
								rtData_s.MainBatteryVoltsErr, _
								rtData_s.VBatVoltsErr, _
								rtData_s.VRefDiffVoltsErr, _
								rtData_s.ProcessorTempErr, _
								rtData_s.Quality, _
								dateTimeStr _
								))
			SQL.TransactionSuccessful
		Catch
			Log(LastException.Message)
			'TODO
		End Try
	Else
		Sleep(10) ' Wait to give db Insert time to complete
	End If
	databseInsertInProgress = False
	bufferDataForGraphs(dateTimeStr)
	displayRealTimeData
	
	For i = 0 To Main.Samples - 1
		Main.xGraph1.CurveY(0, i) = arrayVrms(i)
		Main.xGraph1.CurveY(1, i) = arrayFreq(i)
	Next
	Main.xGraph1.DrawGraph
End Sub


Private Sub displayRealTimeData
	utils.displayStats(Main.tblPowerRecs)
End Sub


private Sub bufferDataForGraphs(dateTimeStr As String)
	' Buffer the data into a circular buffer and display on graph
	'--------------------------------------------------------------------------
'	arrayJTimeEmbed(ptrIn) 	= jTime
'	arrayJTimeClient(ptrIn) = dateTimeStr
	arrayFreq(ptrIn)  		= tempDouble(1)
	arrayVrms(ptrIn)  		= tempFloat(0)
	arraySupplykW(ptrIn) 	= rtData_s.P1
	arraySolarkW(ptrIn) 	= rtData_s.P2
	arrayLoadkW(ptrIn) 		= rtData_s.P2
	arrayQuality(ptrIn)  	= rtData_s.quality

	'Calc Max and Mins
	If ptrIn = 0 Then
		maxF = 0
		minF = 500
		maxV = 0
		minV = 1000
		
		maxSupplykW = 0
		minSupplykW = 100
		maxSolarkW  = 0
		minSolarkW  = 100
		
		maxLoadkW = 0
		minLoadkW = 100
		maxQuality = 0
		minQuality = 1
	Else
		If arrayFreq(ptrIn) > maxF Then maxF = arrayFreq(ptrIn)
		If arrayFreq(ptrIn) < minF Then minF = arrayFreq(ptrIn)
		
		If arrayVrms(ptrIn) > maxV Then maxV = arrayVrms(ptrIn)
		If arrayVrms(ptrIn) < minV Then minV = arrayVrms(ptrIn)
		
		If arraySupplykW(ptrIn) > maxSupplykW Then maxSupplykW = arraySupplykW(ptrIn)
		If arraySupplykW(ptrIn) < minSupplykW Then minSupplykW = arraySupplykW(ptrIn)
		
		If arraySolarkW(ptrIn) > maxSolarkW Then maxSolarkW = arraySolarkW(ptrIn)
		If arraySolarkW(ptrIn) < minSolarkW Then minSolarkW = arraySolarkW(ptrIn)
		
		If arrayLoadkW(ptrIn) > maxLoadkW Then maxLoadkW = arrayLoadkW(ptrIn)
		If arrayLoadkW(ptrIn) < minLoadkW Then minLoadkW = arrayLoadkW(ptrIn)
		
		If arrayQuality(ptrIn) = maxQuality Then maxQuality = arrayQuality(ptrIn)
		If arrayQuality(ptrIn) = minQuality Then minQuality = arrayQuality(ptrIn)
	End If

	' Increment the Circular buffer input ptr
	ptrIn = ptrIn + 1

	If ptrIn = NO_SAMPLES Then
		ptrIn = 0
	End If
	
End Sub

Sub mainMenuBar_Action
	
End Sub

Sub mainMenuBar_SelectedChange (Selected As Boolean)
	
End Sub